#ifdef HAVE_CONFIG_H
 # include <config.h>
#endif

#include <stdlib.h>
 
#ifndef SUB_CALLING
 #include <string.h>
 #include <stdio.h>
 #include <gtk/gtk.h>

 #include "callbacks.h"
 #include "interface.h"
 #include "pfunc.h" 
 #include "support.h"
 #include "sfunc.h"
 #include "mfunc.h"
#endif

#include "rafobj.h"
#include "stf-export.h"
#include "stf-parse.h"
#include "stf.h"

#ifndef ANJUTA_MAKEFILE
 #include "stf-export.c"
 #include "stf-parse.c"
 #include "stf.c"
#endif


void
chiudi_con_modifiche (GtkWidget * padre, int stato)
{
  GtkRequisition wb;

  g_print ("\nTentativo di uscire con modifiche non salvate (%d)", stato);

  if (stato & AVT_DESTROY)
    Status[S_AVVRTM] = stato;
  else
  {
    Status[S_AVVRTM] = stato;
    gtk_widget_size_request (padre, &wb);
    gtk_widget_set_sensitive (padre, FALSE);
    g_print ("\nStato di destroy non settato.");
  }
  Avvertimento = create_avvertimento ();
  MOSTRA_ON_MOUSE (Avvertimento);
}


int
get_whats_key (GdkEventKey * event)
{
  /* su archittetture PC/IBM la posizione e` 20 */
  int evt, key = (int) ((char *) event)[20];

  /* ma su architteture SPARC/SUN laposizione e` 23 */
  if (!key)
    key = (int) ((char *) event)[23];

  /* Meglio prendere il valore con un puntatore */
  evt = event->keyval;

  g_print ("\nkey: 0x%x, keyval: 0x%x = (0x%x, 0x%x)", key, evt, evt & 0xff00, evt & 0x0ff);

  return evt & 0x0ff;
}


void
g_set_window_title (GtkWidget * wind, const char *text)
{
  gchar *title;

  title = g_strdup_printf ("%s", text);
  gtk_window_set_title (GTK_WINDOW (wind), title);
  g_free (title);
}

void
g_set_statusbar (GtkWidget * wind, const char *text)
{
  GtkWidget *statusbar;

  statusbar = lookup_widget (wind, "statusbar");
  gtk_statusbar_pop (GTK_STATUSBAR (statusbar), 1);
  gtk_statusbar_push (GTK_STATUSBAR (statusbar), 1, text);
}


int
carica_rubrica (void)
{
	RAF_DEBUG_INIT{"carica_rubrica"};
  	long k, n, i;
	char *intestazione, *row, 
	*cmp, *rows[MAX_N_NAME];
  	struct card rc;

	/* RAF 2001-06-29: aggiornamento all'uso di rafobj */
	g_print ("\nLoading rubrica file");

	if(Sequenza) 
		M_FREE(Sequenza);
	intestazione = strtok(FileBuffer, "\n");
	if(intestazione) {
		n = 0;
		while( (row = strtok(NULL, "\n")) && n < MAX_N_NAME) {
			if ( !strncasecmp(row, "#seq:", 5) )	{
     	 		/* Impedisce che #seq: in fondo al file 
        		sia scambiato per un nominativo */
				
				/* RAF 2001-07-09: questo codice sembra essere superfluo */
				i = strlen(row); while(i > 0 && row[i] != '"') i--;
				if(i) row[i+1] = 0;
				/* END */				

				Sequenza = duplica_sequenza (row);
				g_print("\nRaggiunta la fine della rubrica."
                "\nTi mostro la sequenza:\n%s\n", Sequenza);
			} else {
				/* RAF 2001-07-09: BUGFIX questo codice evita il crash
				   nel caso il file della rubrica contenga delle linee vuote */
				i = strlen(row); while(i > 0 && row[i] != '"') i--;
				if(i) {
					row[i+1] = 0;
					rows[n] = row;
					g_print("%ld] '%s'\n", n, row);
					n++;
				}
			}
		}

		/* RAF 2001-07-02: salva i campi di intestazione */
		k = 0;
		cmp = get_campi_from(intestazione);
		g_print("CIAO: %s\n", cmp);
		while( cmp && cmp[0] && k < MAX_N_CAMPI ) {
			//M_FREE(Campi[k]);
			Campi[k] = M_STRDUP(cmp); 
			RAF_DEBUG("&Campi[%ld] = 0x%lx %s\n", k, (long)Campi[k], Campi[k]);
			cmp = get_campi_from(intestazione);
			g_print("CIAO: %s\n", cmp);
			k++;
		}		
		Status[S_CAMPI] = k;
		for (; k < MAX_N_CAMPI; k++) 
			M_FREE(Campi[k]) 
	} else return -1;

	if(Sequenza) 
		LungIntst = get_formato_card (Sequenza);
	else 
		return -2;

	for (k = 0; k < n; k++) {
		cmp = strtok(rows[k],"\"\t");
		for(i = 0; i < MAX_N_CAMPI; i++) {
			rc.cmp[i]	= cmp ? strdup(cmp) : NULL;
			g_print("%ld} %s\n", i, rc.cmp[i]);
			cmp = strtok(NULL,"\"\t");
		}	
		rc.cog = rc.cmp[COG];
		rc.nom = rc.cmp[NOM];
		
		raf_obj_manage(RAF_OBJ_ADD, &rc);													
	}

  /* Bisogna pulire la card prima di stampare
   * la nuova altrimenti finisco per appenderla
   * se lo stato di testo risultasse non settato 
   */
  set_testo ("", Base, "text3", TXT_CLEAN);

  /* Il numero di cards e` necessario per 
   * impostare correttamente la nuova lista 
   */
  g_print (" (%ld bytes : %d cards) \n", i, raf_object_get_num);
  imposta_lista ();

  /* Lo stato lo setto alla fine altrimenti 
   * mi prdo il ricordo di quello precedente 
   */
  Status[S_RUBRICA] = 1;
  Status[S_SEQUENZA] = 1;
  Status[S_LISTA] = 1;
  set_sensitive_tools (IF_NEED);

	return 1;
}



void 
esporta_rubrica_in_csv(FILE *f)
{
	RAF_DEBUG_INIT{"","esporta_rubrica_in_csv"};

	StfExportOptions_t *opt;
	Sheet sheet;
	long i = 0, j = 0, n_card;
	struct card *rc;

	n_card = raf_object_get_num;
	RAF_DEBUG("S_CARDS %ld", n_card);
	sheet.range.start_row = 0;
	sheet.range.start_col = 0;
	sheet.range.end_row = n_card+1; // Aggiungo +1 per l'intestazione dei campi 
	sheet.range.end_col = Status[S_CAMPI];
 	RAF_DEBUG("S_CAMPI %d", Status[S_CAMPI]); 

	/* RAF 2001-06-03: Scrivo l'intestazione dei campi */
	i = sheet.range.start_row;
	for(j = sheet.range.start_col; j < sheet.range.end_col; j++) {
		RAF_DEBUG("int] row %ld,  col %ld", i, j);
		sheet.data[i][j] = Campi[j];
  }
  
	/* RAF 2001-06-03: scrivo la tabella dei dati */
	rc = raf_object_get_slt(RAF_FIRST);
	for(++i; i < sheet.range.end_row; i++) 
	{
		RAF_DEBUG("tab] row %ld", i);
		for(j = sheet.range.start_col; j < sheet.range.end_col; j++) {
			RAF_DEBUG("tab] row %ld, col %ld: %s", i, j, rc->cmp[j]);
			sheet.data[i][j] = rc->cmp[j];
		}
		rc = raf_object_get_slt(RAF_NEXT);
	}
	RAF_DEBUG("FINE row %ld,  col %ld", i, j);
	
	opt = stf_export_options_new();
	stf_export_options_set_default(opt);
	stf_export_options_sheet_list_add(opt, &sheet);	

	if(f != NULL) {
		stf_export_options_set_write_callback(opt, (StfEWriteFunc)stf_write_func, f);
		g_print("result %d", stf_export_sheet(opt, &sheet) );
	}
}



void
imposta_lista (void)
{
  long prev_cod;
  char *strn, cod[8];
  GtkWidget *list, *list_item;
  GList *dlist;
	struct card *rc;

  g_print ("\nImposta lista started %d", raf_object_get_ind);
  prev_cod = raf_object_get_cod;
  ordina_lista ();
  g_print (" -> %d\n", raf_object_get_ind);

  dlist = NULL;
	rc = raf_object_get_slt(RAF_FIRST);
  if (abs (Status[S_ORDINE]) == ORD_COG)
		while(rc)
    {
      strn = malloc (strlen (rc->cog) + strlen (rc->nom) + 4);
      sprintf (strn, "%s %s", rc->cog, rc->nom);
      list_item = gtk_list_item_new_with_label (strn);
      dlist = g_list_prepend (dlist, list_item);
      gtk_widget_show (list_item);
			sprintf(cod, "#%05ld", raf_object_get_cod);
      gtk_object_set_data (GTK_OBJECT (list_item), list_item_data_key, strdup(cod));
			rc = raf_object_get_slt(RAF_NEXT);
    }
  else
		while(rc)
    {
      strn = malloc (strlen (rc->cog) + strlen (rc->nom) + 4);
      sprintf (strn, "%s %s", rc->nom, rc->cog);
      list_item = gtk_list_item_new_with_label (strn);
      dlist = g_list_prepend (dlist, list_item);
      gtk_widget_show (list_item);
			sprintf(cod, "#%05ld", raf_object_get_cod);
      gtk_object_set_data (GTK_OBJECT (list_item), list_item_data_key, strdup(cod));
			rc = raf_object_get_slt(RAF_NEXT);
    }
  dlist = g_list_reverse (dlist);

	/* RAF 2001-07-01: riprendo la selezione precedente */
	raf_obj_manage(RAF_OBJ_SLT | RAF_COD, (void *)prev_cod);

  /* Visualizzazione del contenuto della lista 
   * Se la lista era gia` formata occurre pulirla  
   * ricostruire la giusta selezione */
  list = lookup_widget (GTK_WIDGET (Base), "lista");
  if (Status[S_LISTA])
  {
    Status[S_INIBIT] = S_LISTA;
    gtk_list_clear_items (GTK_LIST (list), 0, raf_object_get_num);
    gtk_list_prepend_items (GTK_LIST (list), dlist);
    Status[S_INIBIT] = -1;
    g_print ("\nPippone\n");
		/* RAF 2001-07-02: TODO test */
    set_lista_item (raf_object_get_ind, !S_INIBIT);
  }
  else
    gtk_list_prepend_items (GTK_LIST (list), dlist);

  /*set_sensitive_tools(IF_NEED); */
  g_print ("\nImposta lista returned");
}



/* RAF 2001-06-29: funzioni definite per l'uso con qsort */

int compare_nom_card(const void *el1, const void *el2) 
{
	struct card *e1, *e2;
	e1 = (struct card *)(el1);
	e2 = (struct card *)(el2);

	g_print("1");
	if(e1 == e2) return 0;       
  else if(e1 == NULL) return 1; 
	else if(e2 == NULL) return -1;
	else return strcasecmp(e2->nom, e1->nom);
}

int compare_cog_card(const void *el1, const void *el2) 
{
	struct card *e1, *e2;
	e1 = (struct card *)(el1);
	e2 = (struct card *)(el2);

	g_print("2");
	if(e1 == e2) return 0;       
  else if(e1 == NULL) return 1; 
	else if(e2 == NULL) return -1;
	else return strcasecmp(e2->cog, e1->cog);
}


int compare_inv_nom_card(const void *el1, const void *el2) 
{
	struct card *e1, *e2;
	e1 = (struct card *)(el1);
	e2 = (struct card *)(el2);

	g_print("3");
	if(e1 == e2) return 0;       
  else if(e1 == NULL) return 1; 
	else if(e2 == NULL) return -1;
	else return strcasecmp(e1->nom, e2->nom);
}


int compare_inv_cog_card(const void *el1, const void *el2) 
{
	struct card *e1, *e2;
	e1 = (struct card *)(el1);
	e2 = (struct card *)(el2);

	//g_print("\n4");
	if(e1 == e2) return 0;       
  else if(e1 == NULL) return 1; 
	else if(e2 == NULL) return -1;
	else {
		//g_print("%s,%s\n", e1->cog, e2->cog);
		return strcasecmp(e1->cog, e2->cog);
	}
}


void
ordina_lista (void)
{
  int ord;

  ord = ORD_VTEST (Status[S_ORDINE]);
  g_print ("\nOrdina lista started, verso %d (%d)\n", ord, sizeof(struct card *));

	/* RAF 2001-06-29: l'uso di qsort diventa necessario per
	   ordinare la lista quando il numero di elenti diventa
	   molto grande e con l'algorimo precedente il tempo di
	   riordinamento cresceva come n 
	 */

	/* RAF 2001-07-01: portato dentro a rafobj */
  if (abs (Status[S_ORDINE]) == ORD_COG) {
		if(ord > 0) raf_obj_manage(RAF_OBJ_ORD, (void *)compare_cog_card);	
		else raf_obj_manage(RAF_OBJ_ORD, (void *)compare_inv_cog_card);	 
	} else {
		if(ord > 0) raf_obj_manage(RAF_OBJ_ORD, (void *)compare_nom_card);	
		else raf_obj_manage(RAF_OBJ_ORD, (void *)compare_inv_nom_card);	 
	}

  g_print ("\nfinito ordinamento");
}


void
set_ricerca (const char *strn)
{
  GtkWidget *entry;

  g_print ("\nSet ricerca started ");

  entry = lookup_widget (GTK_WIDGET (Base), "ricerca");
  gtk_entry_set_text (GTK_ENTRY (entry), strn);
  if (!strcmp (strn, ""))
    Status[S_RICERCA] = 0;
  else
    Status[S_RICERCA] = 1;
}


long
trova_ricerca (const char *strn)
{
	int len;
  long k, n_card;
	struct card *rc;
	
	n_card = raf_object_get_num;
  g_print ("\nTrova ricerca started ");

  k = -1;
	len = strlen (strn);
	rc = raf_object_get_slt(RAF_FIRST);
  if (abs(Status[S_ORDINE]) == ORD_COG)
		while(rc) {
      if (!strncasecmp(strn, rc->cog, len))	{
										/* dovrebbe trovare il primo nome ma poiche` la */
				k = raf_object_get_ind;			/* lista e` organizzata in ordine inverso... */
				rc = NULL;
			} else rc = raf_object_get_slt(RAF_NEXT);
		}
  else 
		while(rc) {
      if (!strncasecmp(strn, rc->cog, len))	{
										/* dovrebbe trovare il primo nome ma poiche` la */
				k = raf_object_get_ind;			/* lista e` organizzata in ordine inverso... */
				rc = NULL;
			} else rc = raf_object_get_slt(RAF_NEXT);
		}

  return k;
}


void
reset_lista (void)
{
  GtkWidget *list;

  g_print ("\nReset lista started ");

  list = lookup_widget (GTK_WIDGET (Base), "lista");

  /* gtk_clist_clear( (GtkCList *) GTK_LIST(list)->selection); 
   * gtk_clist_remove( (GtkCList *) GTK_LIST(list)->selection, 0); */
}


void
set_lista_item (int k, int inibit)
{
  int old;
  GtkWidget *list;
  GtkList *glst;

  if (k >= 0)
  {
    g_print ("\nSet lista item started");	// OGGI
    list = lookup_widget (GTK_WIDGET (Base), "lista");
    glst = GTK_LIST (list);

    if (inibit == S_INIBIT)
    {
      g_print (" with inibition");	// OGGI
      old = Status[S_LISTA];
      Status[S_LISTA] = -1;
      gtk_list_select_item (glst, k);
      Status[S_LISTA] = old;
    }
    else
      gtk_list_select_item (glst, k);

		raf_obj_manage(RAF_OBJ_SLT | RAF_IND, (void *)k);
    g_print ("\nSet lista item n.%d", k);
    set_scrolled_window (GTK_WIDGET (Base), "scrolledwindow4", "lista", ON_PAGE);
  }
  else
    g_print ("\nERRORE: codice passato negativo");
}


void
free_memory (void)
{
  int k;
  long i;
  struct stringa *crn, *crf;
  GtkWidget *list;

  g_print ("\nFree memory starting");

  /* ATTENZIONE: free_memory() non e` adatto ad
   * essere chiamato all'uscita del programma */


  /* Questo lo facciamo quando la rubrica e` caricata`
   * perche` altrimenti va tutto a scatafascio.
   * if ( Status[S_TESTO] )
   * set_testo("", Base, "text3", TXT_CLEAN);
   * Status[S_TESTO] = 0;
   * 
   * if ( Status[S_RICERCA] )
   * set_ricerca("");
   * Status[S_RICERCA] = 0;
   */
  Status[S_TESTO] = 0;
  Status[S_RICERCA] = 0;


  /* Prima di allocare altro spazio svuoto il precedente
   * Non posso deallocare NomeFile e SoloNomeFile perche`
   * contengono informazioni e sono stati reallocati di gia` */
  if (Status[S_BUFFER])
  {
    g_print (" #1");
    if (Sequenza != NULL)
      M_FREE (Sequenza);
    if (FileBuffer != NULL)
      M_FREE (FileBuffer);
    Status[S_BUFFER] = 0;
  }

  if (Status[S_LISTA])		/* Se la lista era gia` formata occurre pulirla */
  {
    g_print (" #2");
    list = lookup_widget (GTK_WIDGET (Base), "lista");
    gtk_list_clear_items (GTK_LIST (list), 0, raf_object_get_num);
    Status[S_LISTA] = 0;
  }

	
  if (raf_object_get_num)		/* Occore liberare tutte le strutture */
  {
    g_print (" #3");
		/* RAF 2001-07-02: FIXME eliminare il memory leak sui campi */
		raf_obj_manage(RAF_OBJ_RMV | RAF_ALL, NULL);
  }

  k = 0;
  if (Status[S_CAMPI])
  {
    g_print (" #4");
    crf = Carta.next;
    if (Carta.text != NULL)
      M_FREE (Carta.text);
    while (crf != NULL && crf->next != NULL)
    {
      crn = crf->next;
      if (crf != NULL)
			M_FREE (crf->text);
      M_FREE (crf);
      crf = crn->next;
      k++;
    }

    for (i = 0; i < Status[S_CAMPI]; i++)
      if (Campi[i] != NULL)
				M_FREE (Campi[i]);
		M_FREE_CARD(CardCopia);

    Status[S_CAMPI] = 0;
  }

  g_print (" (%d)", k);
  for (i = 0; i < NUM_STATUS_FLAGS; i++)  /* Inizializzo anche lo status che male non fa */
    if (i != S_ORDINE)                    /* l'ordinamento  pi comodo mantenerlo */
      Status[i] = 0;

  return;
}


void
set_scrolled_window (GtkWidget * container, const char *scrolledwindow,
		     const char *lista, int mth)
{
  GtkAdjustment *Adj;
  GtkObject *list_item;
  GtkWidget *scrollbar;
  gint scroll_y;
  int y1, y2, y;

  list_item = get_selected_list_item (container, lista);
  if (list_item == NULL)
  {
    g_print("\nERRORE: get_selected_list_item ha ritornato un puntatore nullo"
            "\ncontrollare Status[S_LISTA] = %d deve essere 1", Status[S_LISTA]);
    return;
  }
  scroll_y = GTK_WIDGET (list_item)->allocation.y;

  scrollbar = lookup_widget (container, scrolledwindow);
  if (scrollbar == NULL)
  {
    g_print("\nERRORE: la scrollbar ha ritornato un puntatore nullo"
            "\ncontrollare Status[S_LISTA] = %d deve essere 1", Status[S_LISTA]);
    return;
  }

  Adj = gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW (scrollbar));
  g_print ("\nset_scrolled_window started on %s,%s \n( %d < %d + %d < %d )",
	         scrolledwindow, lista,     (int) Adj->value, (int) scroll_y,
	         (int) Adj->step_increment, (int) (Adj->value + Adj->page_size));

  /* POTENZIALE PROBLEMA */
  /* Accade che lo scroll correto della lista venga fatto da imposta_listacampi
   * in seguito la lista si trova in una condizione di scroll_y = -1  */
  if (scroll_y < 0)
    return;

  if (mth == ON_FIRST)
  {
    g_print ("\nCalling vscroll in ON_FIRST mode");
    set_vscroll_window (container, scrolledwindow, scroll_y);
  }
  else if (mth == ON_PAGE)
  {
    y1 = (int) (Adj->value);
    y2 = (int) (Adj->value + Adj->page_size - Adj->step_increment);

    /* Controllo se scroll_y  anche soltanto parzialmente fuori
     * dalla finestra di visualizzazione */
    if (y1 < scroll_y && scroll_y < y2)
      g_print ("\nNo need call to vscroll");
    else
    {
      y1 = (int) (scroll_y / Adj->page_size);
      y2 = (int) ((scroll_y + Adj->step_increment) / Adj->page_size);
      g_print ("\nCalling vscroll in ON_PAGE mode: y1=%d, y2=%d", y1, y2);

      /* se sono diversi significa che sta a cavallo di due pagine */
      if (y1 == y2)
				y = y1 * Adj->page_size;
      else
				y = scroll_y;

      set_vscroll_window (container, scrolledwindow, y);
    }
  }
  else
    g_print ("\nNo call to vscroll because different mode");


  return;
}


void
set_vscroll_window (GtkWidget * container, const char *scrolledwindow,
		    int start)
{
  GtkAdjustment *Adj;
  GtkWidget *scrollbar;

  scrollbar = lookup_widget (container, scrolledwindow);

  /* g_print("\nSet scrolledwindow started (%d): %s %s", scroll_y, scrolledwindow, lista); */
  /* GTK_WIDGET(scrollbar)->allocation.y = scroll_y+14;
   * GTK_WIDGET (list_item)->allocation.y = scroll_y+14;
   * GTK_WIDGET (lst)->allocation.y = scroll_y+14; 
   */

  Adj = gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW (scrollbar));
  g_print("\n\nValori: v(n-1)=%3.1f, v(n)=%3.1f, l=%3.1f, u=%3.1f, s=%3.1f, p=%3.1f, s=%3.1f\n",
          Adj->value, (float) start, Adj->lower, Adj->upper, Adj->step_increment,
          Adj->page_increment, Adj->page_size);

  if (start != Adj->value) ;
  {
    if (start >= 0)
    {
      if (start + Adj->page_size > Adj->upper)
        start = Adj->upper - Adj->page_size;
      Adj->value = start;
      gtk_scrolled_window_set_vadjustment (GTK_SCROLLED_WINDOW (scrollbar), Adj);
      gtk_adjustment_value_changed (Adj);
    }
    else
      g_print ("\nERROR: start must be positve integer (%d)", start);
  }

  return;
}


GtkObject *
get_selected_list_item (GtkWidget * container, const char *widget)
{
  GtkWidget *lst;
  GList *dlist;
  GtkObject *list_item;

  g_print ("\nGet selected list item started: %s", widget);

  list_item = NULL;
  if (Status[S_LISTA] > 0)
  {
    lst = lookup_widget (container, widget);
    dlist = GTK_LIST (lst)->selection;
    while (dlist)		
    {				
      list_item = GTK_OBJECT (dlist->data);	
      dlist = dlist->next;	
    }
  }

  return list_item;
}


void
modifica_ripristina (void)
{
  GtkWidget *text;

  Modifica = create_modifica ();
  text = lookup_widget (GTK_WIDGET (Modifica), "card_preview");
  gtk_text_set_word_wrap (GTK_TEXT (text), 1);

  imposta_listacampi (Modifica, "listacampi");
  set_vscroll_window (Modifica, "scrolledwindow7", 0);
}


void
set_sensitive_tools (int force)
{
  static GtkWidget *menu[20];
  static GtkWidget *oldBase = NULL;
  static int OSRubrica = -99, i;
  static int OSModifica = -99;

  /* I puntatori devono essere inizializzati oppure aggiornati
   * se la finestra Base viene distrutta e poi ricreata */
  if (oldBase != Base || force)
  {
    for (i = 0; i < 20; i++)
      menu[i] = NULL;

    menu[0] = lookup_widget (Base, "salva_con_nome");
    menu[1] = lookup_widget (Base, "cerca");
    menu[2] = lookup_widget (Base, "aggiungi");
    menu[3] = lookup_widget (Base, "modifica");
    menu[4] = lookup_widget (Base, "button_rinomina");
    menu[5] = lookup_widget (Base, "button_aggiungi");
    menu[6] = lookup_widget (Base, "button_modifica");
    menu[7] = lookup_widget (Base, "esporta");
    menu[8] = lookup_widget (Base, "stampa");

    menu[10] = lookup_widget (Base, "salva");
    menu[11] = lookup_widget (Base, "button_salva");

    g_print ("\nBase pointer changed");
  }

  /* Le sensitive dei tools cambiano solo se c'e` stata una
   * modifca nello Status[RUBRICA] oppure la prima volta */
  if (OSRubrica != Status[S_RUBRICA] || force)
  {
    OSRubrica = Status[S_RUBRICA];
    for (i = 0; i < 10 && menu[i]; i++)
      gtk_widget_set_sensitive (menu[i], OSRubrica);
  }

  /* Quelli di indice superiore al nove vengono attivati
   * solo quando  stata apportata una modifica alla rubrica */
  if (OSModifica != Status[S_MODIFICA] || force)
  {
    OSModifica = Status[S_MODIFICA];
    for (i = 10; i < 20 && menu[i]; i++)
      gtk_widget_set_sensitive (menu[i], OSModifica);
  }
}

void
aggiorna_sequenza_modellata (const char *newseq)
{
  GtkWidget *prvtxt;

  /* Se la nuova sequenza e` uguale alla prima non si deve
   * deallocare la vecchia vuol dire che occorre solo aggiornare */
  if (newseq != Sequenza)
  {
    M_FREE (Sequenza);
    Sequenza = (char *) newseq;
  }

  // g_print("(lun=%ld/%d)\n%s\n", lun, strlen(Sequenza), Sequenza);

  LungIntst = get_formato_card (Sequenza);
  if (LungIntst < 0)
    return;

  if (raf_object_get_ind > 0)
    stampa_card (raf_object_get_slt(RAF_OBJ_SLT), Creazione, "crea_preview");
  else
    stampa_card (raf_object_get_slt(RAF_FIRST), Creazione, "crea_preview");
  set_vscroll_window (Creazione, "scrolledwindow9", 0);
  prvtxt = lookup_widget (Creazione, "crea_preview");
  gtk_text_set_editable (GTK_TEXT (prvtxt), 0);

  /* Non e` detto che venga modificato ogni volta */
  /*Status[S_SEQUENZA] = -1; */
}
